package rip.tilly.bedwars.player;

import lombok.Getter;
import org.bukkit.ChatColor;
import org.bukkit.Color;

import java.util.Arrays;

/**
 * Created by Lucanius
 * Project: BedWars
 */
@Getter
public enum PlayerTeam {

    WHITE("White", Color.WHITE, ChatColor.WHITE),
    SILVER("Silver", Color.SILVER, ChatColor.GRAY),
    GRAY("Gray", Color.GRAY, ChatColor.DARK_GRAY),
    BLACK("Black", Color.BLACK, ChatColor.BLACK),
    BLUE("Blue", Color.BLUE, ChatColor.BLUE),
    NAVY("Navy", Color.NAVY, ChatColor.DARK_BLUE),
    CYAN("Cyan", Color.TEAL, ChatColor.DARK_AQUA),
    AQUA("Aqua", Color.AQUA, ChatColor.AQUA),
    LIME("Lime", Color.LIME, ChatColor.GREEN),
    GREEN("Green", Color.GREEN, ChatColor.DARK_GREEN),
    YELLOW("Yellow", Color.YELLOW, ChatColor.YELLOW),
    ORANGE("Orange", Color.ORANGE, ChatColor.GOLD),
    RED("Red", Color.RED, ChatColor.RED),
    MAROON("Maroon", Color.MAROON, ChatColor.DARK_RED),
    PURPLE("Purple", Color.PURPLE, ChatColor.DARK_PURPLE),
    PINK("Pink", Color.FUCHSIA, ChatColor.LIGHT_PURPLE);

    private final String name;
    private final Color color;
    private final ChatColor chatColor;

    PlayerTeam(String name, Color color, ChatColor chatColor) {
        this.name = name;
        this.color = color;
        this.chatColor = chatColor;
    }

    public static PlayerTeam getFromName(String name) {
        return Arrays.stream(values()).filter((team) -> team.name.equalsIgnoreCase(name) || team.getName().equalsIgnoreCase(name)).findFirst().orElse(null);
    }
}
